///////////////////////////////////////////////
// 
//  Tekram-S
//  Made for Ludum Dare 48h game design competition, April 2004
//  (theme 'infection')
//
//  Jari Komppa aka Sol 
//  http://iki.fi/sol
// 
///////////////////////////////////////////////
// License
///////////////////////////////////////////////
// 
//     This software is provided 'as-is', without any express or implied
//     warranty.    In no event will the authors be held liable for any damages
//     arising from the use of this software.
// 
//     Permission is granted to anyone to use this software for any purpose,
//     including commercial applications, and to alter it and redistribute it
//     freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//        claim that you wrote the original software. If you use this software
//        in a product, an acknowledgment in the product documentation would be
//        appreciated but is not required.
//     2. Altered source versions must be plainly marked as such, and must not be
//        misrepresented as being the original software.
//     3. This notice may not be removed or altered from any source distribution.
// 
// (eg. same as ZLIB license)
//
///////////////////////////////////////////////

class Gene;
class Person;
class Popupnote;
class GameScreen : public Screen
{
public:
    int mSize;
    int mToolSize;
    int mKitSize;
    int mInspectOffset;
    int mCurrentPerson;
    int mMouseyPerson;
    int mVaccinating;
    int mVaccinatingDoneTick;
    int mVaccineCount;
    int mOutbreakPeriod;
    Gene ** mOldVaccines;
    int * mOldVaccineRecentlyUsed;
    Gene * mToolBoard;
    Person **mPopulation;
    GameScreen(int difficulty);
    ~GameScreen();
    virtual void render();
    virtual void mouseup(int x, int y);
    virtual void mousedown(int x, int y);
    virtual void mousemove(int x, int y);
    void vaccinate();
    void disease_tick();
    void outbreak();
    void do_vaccinate();
    void do_clear();
    void do_invert();
    void do_hflip();
    void do_vflip();
    SDL_Surface *mBackground;
    Popupnote *mPopuproot;
    void addpopup(int x, int y, int type);
};
