///////////////////////////////////////////////
// 
//  Tekram-S
//  Made for Ludum Dare 48h game design competition, April 2004
//  (theme 'infection')
//
//  Jari Komppa aka Sol 
//  http://iki.fi/sol
// 
///////////////////////////////////////////////
// License
///////////////////////////////////////////////
// 
//     This software is provided 'as-is', without any express or implied
//     warranty.    In no event will the authors be held liable for any damages
//     arising from the use of this software.
// 
//     Permission is granted to anyone to use this software for any purpose,
//     including commercial applications, and to alter it and redistribute it
//     freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//        claim that you wrote the original software. If you use this software
//        in a product, an acknowledgment in the product documentation would be
//        appreciated but is not required.
//     2. Altered source versions must be plainly marked as such, and must not be
//        misrepresented as being the original software.
//     3. This notice may not be removed or altered from any source distribution.
// 
// (eg. same as ZLIB license)
//
///////////////////////////////////////////////

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <SDL.h>

#define TO16B(r,g,b) ((((r) >> 3) & 0x1f) << 11) | ((((g) >> 3) & 0x1f) << 6) | ((((b) >> 3) & 0x1f) << 0)
#define VACCINATION_TIME_MS 1000
#define OUTBREAK_MS 5000
#define MINOUTBREAK_MS 2000
#define DISEASETICK_MS 100
#define MUTATEFACTOR_NEW 1
#define MUTATEFACTOR_SAME 3
#define MUTATEFACTOR_DIFFERENT 8
#define MAX_POPUPNOTE_TICKS 8

enum gamestates
{
    STATE_NOTCHANGING,
    STATE_INTRO,
    STATE_MENU,
    STATE_GAME,
    STATE_GAMEOVER,
    STATE_GAMEWIN
};

class Screen;

extern SDL_Surface *gScreen;
extern SDL_Surface *gMutation;
extern SDL_Surface *gOutbreak;
extern int gGameStartTick;
extern int gGameLastTick;
extern int gChangeState;
extern int gCurrentState;
extern int gDifficulty;
extern int gGraph[];
extern int gGraphMax;
extern void simplefillrect(int x1, int y1, int x2, int y2, int color);
extern void simplefillquad(int x1, int y1, int x2, int y2, int color, int thickness);



