///////////////////////////////////////////////
// 
//  Tekram-S
//  Made for Ludum Dare 48h game design competition, April 2004
//  (theme 'infection')
//
//  Jari Komppa aka Sol 
//  http://iki.fi/sol
// 
///////////////////////////////////////////////
// License
///////////////////////////////////////////////
// 
//     This software is provided 'as-is', without any express or implied
//     warranty.    In no event will the authors be held liable for any damages
//     arising from the use of this software.
// 
//     Permission is granted to anyone to use this software for any purpose,
//     including commercial applications, and to alter it and redistribute it
//     freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//        claim that you wrote the original software. If you use this software
//        in a product, an acknowledgment in the product documentation would be
//        appreciated but is not required.
//     2. Altered source versions must be plainly marked as such, and must not be
//        misrepresented as being the original software.
//     3. This notice may not be removed or altered from any source distribution.
// 
// (eg. same as ZLIB license)
//
///////////////////////////////////////////////

#include "globals.h"
#include "screen.h"
#include "introscreen.h"

void IntroScreen::render()
{
    // render background
    SDL_BlitSurface(mBackground, NULL, gScreen, NULL);
    SDL_UpdateRect(gScreen, 0, 0, 640, 480);
    SDL_Delay(10);
}

void IntroScreen::mouseup(int x, int y)
{
    if (mState == 4)
    {
        gChangeState = STATE_MENU;
        return;
    }
    SDL_Surface *temp = NULL;
    switch (mState)
    {
    case 0:
        temp = SDL_LoadBMP("tutorial1.bmp");
        break;
    case 1:
        temp = SDL_LoadBMP("tutorial2.bmp");
        break;
    case 2:
        temp = SDL_LoadBMP("tutorial3.bmp");
        break;
    case 3:
        temp = SDL_LoadBMP("tutorial4.bmp");
        break;
    }
    if (mBackground)
        SDL_FreeSurface(mBackground);
    mBackground = SDL_ConvertSurface(temp, gScreen->format,SDL_SWSURFACE);
    SDL_FreeSurface(temp);
    mState++;
}

void IntroScreen::mousedown(int x, int y)
{
}

void IntroScreen::mousemove(int x, int y)
{
}


IntroScreen::IntroScreen()
{
    mState = 0;
    SDL_Surface *temp = SDL_LoadBMP("tutorial0.bmp");
    mBackground = SDL_ConvertSurface(temp, gScreen->format,SDL_SWSURFACE);
    SDL_FreeSurface(temp);
}

IntroScreen::~IntroScreen()
{
    SDL_FreeSurface(mBackground);
}

