///////////////////////////////////////////////
// 
//  Tekram-S
//  Made for Ludum Dare 48h game design competition, April 2004
//  (theme 'infection')
//
//  Jari Komppa aka Sol 
//  http://iki.fi/sol
// 
///////////////////////////////////////////////
// License
///////////////////////////////////////////////
// 
//     This software is provided 'as-is', without any express or implied
//     warranty.    In no event will the authors be held liable for any damages
//     arising from the use of this software.
// 
//     Permission is granted to anyone to use this software for any purpose,
//     including commercial applications, and to alter it and redistribute it
//     freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//        claim that you wrote the original software. If you use this software
//        in a product, an acknowledgment in the product documentation would be
//        appreciated but is not required.
//     2. Altered source versions must be plainly marked as such, and must not be
//        misrepresented as being the original software.
//     3. This notice may not be removed or altered from any source distribution.
// 
// (eg. same as ZLIB license)
//
///////////////////////////////////////////////

#include "globals.h"
#include "screen.h"
#include "menuscreen.h"

MenuScreen::MenuScreen()
{
    SDL_Surface *temp = SDL_LoadBMP("menu.bmp");
    mBackground = SDL_ConvertSurface(temp, gScreen->format,SDL_SWSURFACE);
    SDL_FreeSurface(temp);
    mHoverItem = -1;
}

MenuScreen::~MenuScreen()
{
    SDL_FreeSurface(mBackground);
}


void MenuScreen::render()
{
    SDL_BlitSurface(mBackground, NULL, gScreen, NULL);        
    if (mHoverItem != gDifficulty)
    {
        if (mHoverItem >= 0 && 
            mHoverItem < 6)
        {
            simplefillrect(452, 210 + mHoverItem * 38, 452+10, 210+10 + mHoverItem * 38, TO16B(0, 0, 0x7f));
            simplefillrect(452-4, 210 + mHoverItem * 38 - 4, 452+10 - 4, 210+10 + mHoverItem * 38 - 4, TO16B(0x7f, 0x7f, 0xdf));
        }
    }
    simplefillrect(452, 210 + gDifficulty * 38, 452+10, 210+10 + gDifficulty * 38, TO16B(0, 0, 0x7f));
    simplefillrect(452-2, 210 + gDifficulty * 38 - 2, 452+10 - 2, 210+10 + gDifficulty * 38 - 2, TO16B(0x7f, 0x7f, 0xdf));

    if (mHoverItem == 100)
    {
        simplefillquad(50,160,350,220,TO16B(0, 0, 0x7f),4);
        simplefillquad(50-2,160-2,350-2,220-2,TO16B(0x7f, 0x7f, 0xdf),4);
    }

    if (mHoverItem == 101)
    {
        simplefillquad(50,260,350,320,TO16B(0, 0, 0x7f),4);
        simplefillquad(50-2,260-2,350-2,320-2,TO16B(0x7f, 0x7f, 0xdf),4);
    }
    if (mHoverItem == 102)
    {
        simplefillquad(50,360,350,420,TO16B(0, 0, 0x7f),4);
        simplefillquad(50-2,360-2,350-2,420-2,TO16B(0x7f, 0x7f, 0xdf),4);
    }
    SDL_UpdateRect(gScreen, 0, 0, 640, 480);
    SDL_Delay(10);
}

void MenuScreen::mouseup(int x, int y)
{
    int i;
    for (i = 0; i < 6; i++)
    {
        if (x >= 450 && x < 600 &&
            y >= 200 + 38 * i &&
            y < 238 + 38 * i)
        {
            gDifficulty = i;
            return;
        }
    }
    if (x >= 50 && x < 350)
    {
        if (y >= 160 && y < 220)
        {
            gChangeState = STATE_GAME;
            return;
        }
        if (y >= 260 && y < 320)
        {
            gChangeState = STATE_INTRO;
            return;
        }
        if (y >= 360 && y < 420)
        {
            exit(0);
            return;
        }
    }

}

void MenuScreen::mousedown(int x, int y)
{
}

void MenuScreen::mousemove(int x, int y)
{
    mHoverItem = -1;
    int i;
    for (i = 0; i < 6; i++)
    {
        if (x >= 450 && x < 600 &&
            y >= 200 + 38 * i &&
            y < 238 + 38 * i)
        {
            mHoverItem = i;
            return;
        }
    }
    if (x >= 50 && x < 350)
    {
        if (y >= 160 && y < 220)
        {
            mHoverItem = 100;
            return;
        }
        if (y >= 260 && y < 320)
        {
            mHoverItem = 101;
            return;
        }
        if (y >= 360 && y < 420)
        {
            mHoverItem = 102;
            return;
        }
    }
}
