///////////////////////////////////////////////
// 
//  Tekram-S
//  Made for Ludum Dare 48h game design competition, April 2004
//  (theme 'infection')
//
//  Jari Komppa aka Sol 
//  http://iki.fi/sol
// 
///////////////////////////////////////////////
// License
///////////////////////////////////////////////
// 
//     This software is provided 'as-is', without any express or implied
//     warranty.    In no event will the authors be held liable for any damages
//     arising from the use of this software.
// 
//     Permission is granted to anyone to use this software for any purpose,
//     including commercial applications, and to alter it and redistribute it
//     freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//        claim that you wrote the original software. If you use this software
//        in a product, an acknowledgment in the product documentation would be
//        appreciated but is not required.
//     2. Altered source versions must be plainly marked as such, and must not be
//        misrepresented as being the original software.
//     3. This notice may not be removed or altered from any source distribution.
// 
// (eg. same as ZLIB license)
//
///////////////////////////////////////////////

#include "globals.h"
#include "gene.h"

Gene::~Gene()
{
    delete[] mGrid;
    mGrid = NULL;
}

Gene::Gene(int aSize)
{
    mGeneColor = 0;
    mSize = aSize;
    mGrid = new int[aSize * aSize];
    memset(mGrid, 0, sizeof(int) * aSize * aSize);
}

int Gene::compare(Gene *aOther)
{
    if (mGeneColor != aOther->mGeneColor)
        return 0;
    int i;
    for (i = 0; i < mSize * mSize; i++)
        if (aOther->mGrid[i] != mGrid[i])
            return 0;
    return 1;
}

void Gene::clone(Gene *aTarget)
{
    memcpy(aTarget->mGrid, mGrid, sizeof(int) * mSize * mSize);
    aTarget->mGeneColor = mGeneColor;
}

void Gene::generate_color()
{
    int r = 0x7f;
    int g = 0;
    int i;
    for (i = 0; i < mSize * mSize; i++)
        if (mGrid[i]) g++;
    g = (0x7f * g) / (mSize * mSize);
    mGeneColor = TO16B(0x7f, g, 0x7f - g);
}


